include:
  - project: 'ntof/daq/common/tools/gitlab-ci-utils'
    file: 'ci/scripts/gitlab-ci-artifacts.yml'

cache:
  key: ref-cache
  paths:
    - .cache

stages:
  - update
  - test
  - build
  - deploy

# Update references cache
cache-update:
  image: gitlab-registry.cern.ch/mro/common/docs/xml2rfc
  stage: update
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule" 
  script:
    - rm -rf .cache
    - ./scripts/gen-all.sh

# Build and deploy docs
build:
  image: gitlab-registry.cern.ch/mro/common/docs/xml2rfc
  stage: build
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  script:
    - ./scripts/update-references.sh
    - ./scripts/gen-all.sh
    - ./scripts/dist.sh
    - mv dist public
  artifacts:
    paths:
      - public

deploy:
  extends: .ci-artifacts
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  dependencies: [ build ]
  variables:
    DEPLOY_DIR: '../docs'

# Generate docs
test:
  image: gitlab-registry.cern.ch/mro/common/docs/xml2rfc
  stage: test
  rules:
    - if: $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
  script:
    - ./scripts/update-references.sh
    - ./scripts/gen-all.sh
